//##############################################################################
// Orulex interface
// Copyright 2005-2008 Artlav
//##############################################################################
 
#ifndef _ORUSDK_H
#define _ORUSDK_H    
                 
#include "Orbitersdk.h"

//Types
typedef union{
 double data[4];
 struct {double x,y,z,m;};
}VECTOR4;

VECTOR4 v32v4(VECTOR3 v)
{
 VECTOR4 v4;
 v4.x=v.x;
 v4.y=v.y;
 v4.z=v.z;
 v4.m=0;
 return v4;
}

//General functions         
double  (__cdecl *porugetaltbyvec)(VECTOR4 pos); //
double  (__cdecl *porugetmaxalt)();              //+
bool    (__cdecl *poruchk)();                    //+

//Internal
HMODULE tosdkhlib;
bool oruisinit=false;

//############################################################################//
//Initilisation
//############################################################################//
int InitOrulexSDK()
{ 
 oruisinit=false;
 porugetaltbyvec=NULL;
 porugetmaxalt=NULL;
 poruchk=NULL;
 
 tosdkhlib=LoadLibrary("modules\\orulex.dll");
 if(!tosdkhlib){
  return 0;
 }else{  
  porugetaltbyvec=(double(__cdecl *)(VECTOR4))GetProcAddress(tosdkhlib,"orugetaltbyvec");
  porugetmaxalt=  (double(__cdecl *)())       GetProcAddress(tosdkhlib,"orugetmaxalt");
  poruchk=        (bool  (__cdecl *)())       GetProcAddress(tosdkhlib,"oruchk");
          
  if(porugetaltbyvec==NULL ||
     porugetmaxalt==NULL ||
     poruchk==NULL)
  {return 0;}      
 }
 oruisinit=TRUE;
 return 1;
}

//############################################################################//
//Wrappers
//############################################################################//

//Check if Orulex installed and active
bool ORUCheck(){if(!oruisinit)return 0;return poruchk();}

//Get elevation by global planet-relative position, in distance from center
double ORUGetElevByVec(VECTOR4 pos)
{
 if(!oruisinit)return 0;
 return porugetaltbyvec(pos);
}  

//Get altitude limit
double ORUGetMaxElev(){if(!oruisinit)return 0;return porugetmaxalt();}
#endif
